package org.runetracker.actions;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import javax.swing.SwingUtilities;

import org.runetracker.SettingsManager;
import org.runetracker.TrayIconControllerManager;
import org.runetracker.Updater;

public class UpdateNow implements ActionListener {
	@Override
	public void actionPerformed(ActionEvent e) {
		final String displayName = SettingsManager.getInstance().getSettings().getDisplayName();
		if (displayName != null) {
			TrayIconControllerManager.getInstance().getTrayIconController().setBusy(true);
			Thread t = new Thread(new Runnable() {
				@Override
				public void run() {
					try {
						Updater.perform(displayName);
						SwingUtilities.invokeLater(new Runnable() {
							@Override
							public void run() {
								TrayIconControllerManager.getInstance().getTrayIconController().setBusy(false);
								TrayIconControllerManager.getInstance().getTrayIconController().setInError(false);
							}
						});
					} catch (final IOException e1) {
						SwingUtilities.invokeLater(new Runnable() {
							@Override
							public void run() {
								TrayIconControllerManager.getInstance().getTrayIconController().setBusy(false);
								TrayIconControllerManager.getInstance().getTrayIconController().setInError(true);
								e1.printStackTrace();
							}
						});
					}
				}
			});
			t.setDaemon(true);
			t.start();
		}
	}
}
